
.686
.model flat, stdcall
option casemap :none

include			windows.inc
include			user32.inc
include			kernel32.inc
include			masm32.inc
include			macros.asm
include  		advapi32.inc

includelib		user32.lib
includelib		kernel32.lib
includelib		masm32.lib
includelib		advapi32.lib

DialogProc		PROTO :DWORD,:DWORD,:DWORD,:DWORD

.const
DLG_NAME			equ 101
BTN_REG			equ 102
BTN_EXIT			equ 103

.data
of_Reg			db '&Register',0
of_Exit			db 'E&xit',0
Caption1			db ';)',0
Caption2			db ':(',0
SubKey			BYTE 'Software\Test\SubTest\Config',0
AddRegValue1		BYTE 'xxxxxxxxxx',0
AddRegValue2		BYTE 'Name',0
RegCode			BYTE 'yyyyyyyyyy',0
RegName			BYTE 'test',0

.data?

hInstance		dd ?
hWnd				dd ?

RegH				PHKEY ?
OutRegName		LOGFONT <>

.code
main:

	invoke GetModuleHandle,0
        invoke DialogBoxParam,eax,100,0,addr DialogProc,0
        
        invoke ExitProcess,0

align 16

DialogProc proc uses ebx esi edi hwnd:dword,message:dword,wparam:dword,lparam:dword
	
	mov eax,message
	.if eax==WM_INITDIALOG

		invoke SetDlgItemText,hwnd,DLG_NAME,addr RegName
		invoke SetDlgItemText,hwnd,BTN_EXIT,addr of_Exit
		invoke SetDlgItemText,hwnd,BTN_REG,addr of_Reg
	
	.elseif eax==WM_COMMAND
	
		mov eax,wparam
		.if eax==BTN_REG
		
		invoke RegCreateKey, HKEY_CURRENT_USER, addr SubKey, addr RegH
  	.if eax==ERROR_SUCCESS
	
  	invoke RegSetValueEx, RegH, addr AddRegValue1, 0, REG_SZ, addr RegCode, sizeof RegCode
	invoke GetDlgItemText,hwnd,DLG_NAME,offset OutRegName, sizeof OutRegName
	invoke RegSetValueEx, RegH, addr AddRegValue2, 0, REG_SZ, addr OutRegName, sizeof OutRegName
  .endif
  .if eax==ERROR_SUCCESS
  invoke MessageBox,hwnd,chr$("Add to registry successfull!   "),addr Caption1,MB_ICONQUESTION+MB_TOPMOST
  .else
  invoke MessageBox,hwnd,chr$("Add to registry failed!   "),addr Caption2,MB_ICONERROR+MB_TOPMOST
  .endif
  .endif
  .endif

 
 .if eax==BTN_EXIT
	invoke EndDialog,hwnd,0
		
 .elseif eax==WM_CLOSE
	invoke EndDialog,hwnd,0
 
 .elseif message==WM_LBUTTONDOWN
	invoke SendMessage,hwnd,WM_NCLBUTTONDOWN,HTCAPTION,0
 .endif
	
	xor eax,eax
	ret 	                         
DialogProc endp

end main
